# -*- coding: utf-8 -*-
#
# File: GuestBookView.py
#
# Copyright (c) 2008 by Finn Arild Music - http://www.finnarild.com - like this
# guestbook? Check out my music!
# Generator: ArchGenXML Version 2.0
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#

__author__ = """Finn Arild Aasheim <unknown>"""
__docformat__ = 'plaintext'

##code-section module-header #fill in your manual code here
from Products.CMFCore.utils import getToolByName
from Products.CMFPlone.utils import safe_hasattr

from DateTime import DateTime
from AccessControl.SecurityManagement import getSecurityManager, setSecurityManager
from AccessControl.ImplPython import SecurityManager
class AnythingGoesManager(SecurityManager):
    def validate(*args, **kw): return True
    def DTMLValidate(*args, **kw): return True
    def checkPermission(*args, **kw): return True
##/code-section module-header

from zope import interface
from zope import component
from Products.CMFPlone import utils
from Products.Five import BrowserView
from zope.interface import implements

from Products.CMFDynamicViewFTI.browserdefault import BrowserDefaultMixin


class GuestBookView(BrowserView):
    """
    """

    ##code-section class-header_GuestBookView #fill in your manual code here
    ##/code-section class-header_GuestBookView



    def hidesEmail(self):
        if self.context.getShowEMail():
            return False
        else:
            return True


    def hasCaptcha(self):
        if safe_hasattr(self.context, 'portal_captchas'):
            return True
        else:
            return False


    def getEntries(self):
        """Get entries to display
        """
        # Start from which entry
        pc = getToolByName(self.context, 'portal_catalog')
        res = pc.searchResults(path='/'.join(self.context.getPhysicalPath()), portal_type="GuestBookEntry", sort_on='created', sort_order='reverse')
        return res


    def getEntryCount(self):
        """How many entries there are
        """
        pc = getToolByName(self.context, 'portal_catalog')
        res = pc.searchResults(path=self.context.absolute_url_path(), portal_type="GuestBookEntry")
        return len(res)


    def getBeautifulDate(self, object):
        return object.creation_date.strftime("%d.%m.%Y %H:%M")


    def _validateGuestbookEntry(self):
        # First check if we have CAPTCHA then validate that
        test_key = self.request.get('key', '')
        hashkey = self.request.get('hashkey', '')
        if not test_key:
            self.validationerrors.append(('key', 'Please enter the validation code'))
            self.validationerrors.append(('captcha', 'Please enter the validation code'))
        elif self.hasCaptcha() and hashkey:
            from Products.qPloneCaptchas.utils import decrypt, parseKey,  encrypt1, getWord
            decrypted_key = decrypt(self.context.captcha_key, hashkey)
            parsed_key = parseKey(decrypted_key)

            index = parsed_key['key']
            date = parsed_key['date']

            img = getattr(self.context, '%s.jpg' % index)
            solution = img.title

            enc = encrypt1(test_key)

            captcha_tool = getToolByName(self.context, 'portal_captchas')
            if (enc != solution) or (captcha_tool.has_key(decrypted_key)) \
                or (DateTime().timeTime() - float(date)>3600):
                    self.validationerrors.append(('key', 'Please re-enter validation code'))
                    self.validationerrors.append(('captcha', 'Please re-enter validation code'))
            else:
                captcha_tool.addExpiredKey(decrypted_key)

        # Name must be entered
        if not self.request.get('entryname', None):
            self.validationerrors.append(('entryname', 'You must enter a name'))

        # E-mail must be valid
        if not self.context.MailHost.validateSingleEmailAddress(self.request.get('entrymail', None)):
            self.validationerrors.append(('entrymail', 'You must enter a valid e-mail address'))

        # Text must be entered
        if not self.request.get('entrytext', None):
            self.validationerrors.append(('entrytext', 'You must write a message'))
        if len(self.request.get('entrytext', '')) < 5:
            self.validationerrors.append(('entrytext', 'Message is too short'))

        self.request.response.validationerrors = self.validationerrors


    def getGoodUrl(self, object):
        url = object.getHomepage()
        if url.startswith('http://') or url.startswith('https://'):
            return url
        else:
            return 'http://' + url


    def getValidationerrors(self):
        return dict(self.validationerrors)


    def addEntry(self):
        entryid = str(self.getEntryCount()+1)
        while safe_hasattr(self.context, entryid):
            entryid = str(int(entryid)+1)
        entryname = self.request.get('entryname', '')
        entrymail = self.request.get('entrymail', '')
        entryaddr = self.request.get('entryaddr', '')
        entrytext = self.request.get('entrytext', '')

        # New security manager to create the entry
        osm = getSecurityManager()
        anythingGoesManager = AnythingGoesManager(osm._thread_id, osm._context)
        setSecurityManager(anythingGoesManager)
        # Create the entry
        self.context.invokeFactory('GuestBookEntry', entryid,
                                   email=entrymail,
                                   homepage=entryaddr,
                                   message=entrytext)
        self.context[entryid].setTitle(entryname)
        # Back to normal security
        setSecurityManager(osm)


    def __call__(self, *args, **kw):
        """Handle the form logic
        """
        #if self.request.get('moreproducts', None) == "Add more products":
        if self.request.get('add_message', None):
            self._validateGuestbookEntry()
            if len(self.validationerrors) > 0:
                pass #just return
            else:
                # store the entry and redirect to self (loosing the entry)
                self.addEntry()
                self.request.response.redirect(self.context.absolute_url_path())

        return super(GuestBookView, self).__call__(*args, **kw)


    def __init__(self, context, request):
        """Initialize
        """
        self.context = context
        self.request = request
        self.validationerrors = self.request.get('validationerrors', [])


##code-section module-footer #fill in your manual code here
##/code-section module-footer


