# -*- coding: utf-8 -*-
#
# File: setuphandlers.py
#
# Copyright (c) 2008 by Finn Arild Music - http://www.finnarild.com - like this
# guestbook? Check out my music!
# Generator: ArchGenXML Version 2.0
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#

__author__ = """Finn Arild Aasheim <unknown>"""
__docformat__ = 'plaintext'


import logging
logger = logging.getLogger('FinnsGuestBook: setuphandlers')
from Products.FinnsGuestBook.config import PROJECTNAME
from Products.FinnsGuestBook.config import DEPENDENCIES
import os
from Products.CMFCore.utils import getToolByName
import transaction
##code-section HEAD
##/code-section HEAD

def isNotFinnsGuestBookProfile(context):
    return context.readDataFile("FinnsGuestBook_marker.txt") is None

def setupHideMetaTypesFromNavigations(context):
    """hide selected classes in the search form"""
    if isNotFinnsGuestBookProfile(context): return 
    # XXX use https://svn.plone.org/svn/collective/DIYPloneStyle/trunk/profiles/default/properties.xml
    shortContext = context._profile_path.split(os.path.sep)[-3]
    if shortContext != 'FinnsGuestBook': # avoid infinite recursions
        return
    site = context.getSite()
    portalProperties = getToolByName(site, 'portal_properties')
    siteProperties = getattr(portalProperties, 'site_properties')
    for klass in ['GuestBookEntry']:
        propertyid = 'metaTypesNotToList'
        lines = list(siteProperties.getProperty(propertyid) or [])
        if klass not in lines:
            lines.append(klass)
            siteProperties.manage_changeProperties(**{propertyid: lines})



def updateRoleMappings(context):
    """after workflow changed update the roles mapping. this is like pressing
    the button 'Update Security Setting' and portal_workflow"""
    if isNotFinnsGuestBookProfile(context): return 
    shortContext = context._profile_path.split(os.path.sep)[-3]
    if shortContext != 'FinnsGuestBook': # avoid infinite recursions
        return
    wft = getToolByName(context.getSite(), 'portal_workflow')
    wft.updateRoleMappings()

def postInstall(context):
    """Called as at the end of the setup process. """
    # the right place for your custom code
    if isNotFinnsGuestBookProfile(context): return
    shortContext = context._profile_path.split(os.path.sep)[-3]
    if shortContext != 'FinnsGuestBook': # avoid infinite recursions
        return
    site = context.getSite()



##code-section FOOT
##/code-section FOOT
